Index: branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90
===================================================================
--- branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90	(revision 10574)
+++ branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbgc.F90	(revision 10622)
@@ -1589,4 +2115,11 @@
                   &                         pco2_balinc(:,:,:,jp_had0:jp_had1)
                trb(:,:,:,jp_had0:jp_had1) = trn(:,:,:,jp_had0:jp_had1)
+            END WHERE
+#elif defined key_fabm
+            WHERE( pco2_balinc(:,:,:,jp_fabm0:jp_fabm1) > 0.0_wp .OR. &
+               &   trn(:,:,:,jp_fabm0:jp_fabm1) + pco2_balinc(:,:,:,jp_fabm0:jp_fabm1) > 0.0_wp )
+               trn(:,:,:,jp_fabm0:jp_fabm1) = trn(:,:,:,jp_fabm0:jp_fabm1) + &
+                  &                           pco2_balinc(:,:,:,jp_fabm0:jp_fabm1)
+               trb(:,:,:,jp_fabm0:jp_fabm1) = trn(:,:,:,jp_fabm0:jp_fabm1)
             END WHERE
 #endif
@@ -1854,9 +2387,11 @@
 
          IF ( ln_pno3inc ) THEN
-#if defined key_hadocc || defined key_medusa
+#if defined key_hadocc || defined key_medusa || defined key_fabm
 #if defined key_hadocc
             it = jp_had_nut
 #elif defined key_medusa
             it = jpdin
+#elif defined key_fabm
+            it = jp_fabm_n3n
 #endif
             IF ( ln_phytobal ) THEN
@@ -1878,6 +2413,10 @@
 
          IF ( ln_psi4inc ) THEN
+#if defined key_medusa || defined key_fabm
 #if defined key_medusa
             it = jpsil
+#elif defined key_fabm
+            it = jp_fabm_n5s
+#endif
             IF ( ln_phytobal ) THEN
                psi4_bkginc(:,:,:) = psi4_bkginc(:,:,:) - phyto2d_balinc(:,:,:,it)
@@ -1898,9 +2437,11 @@
 
          IF ( ln_pdicinc ) THEN
-#if defined key_hadocc || defined key_medusa
+#if defined key_hadocc || defined key_medusa || defined key_fabm
 #if defined key_hadocc
             it = jp_had_dic
 #elif defined key_medusa
             it = jpdic
+#elif defined key_fabm
+            it = jp_fabm_o3c
 #endif
             IF ( ln_phytobal ) THEN
@@ -1922,9 +2463,11 @@
 
          IF ( ln_palkinc ) THEN
-#if defined key_hadocc || defined key_medusa
+#if defined key_hadocc || defined key_medusa || defined key_fabm
 #if defined key_hadocc
             it = jp_had_alk
 #elif defined key_medusa
             it = jpalk
+#elif defined key_fabm
+            it = jp_fabm_o3ba
 #endif
             IF ( ln_phytobal ) THEN
@@ -1946,6 +2489,10 @@
 
          IF ( ln_po2inc ) THEN
+#if defined key_medusa || defined key_fabm
 #if defined key_medusa
             it = jpoxy
+#elif defined key_fabm
+            it = jp_fabm_o2o
+#endif
             IF ( ln_phytobal ) THEN
                po2_bkginc(:,:,:) = po2_bkginc(:,:,:) - phyto2d_balinc(:,:,:,it)
@@ -2004,4 +2551,10 @@
                   trb(:,:,:,jpdin) = trb(:,:,:,jpdin) + pno3_bkginc(:,:,:) * zincwgt
                END WHERE
+#elif defined key_fabm
+               WHERE( pno3_bkginc(:,:,:) > 0.0_wp .OR. &
+                  &   trn(:,:,:,jp_fabm_n3n) + pno3_bkginc(:,:,:) * zincwgt > 0.0_wp )
+                  trn(:,:,:,jp_fabm_n3n) = trn(:,:,:,jp_fabm_n3n) + pno3_bkginc(:,:,:) * zincwgt
+                  trb(:,:,:,jp_fabm_n3n) = trb(:,:,:,jp_fabm_n3n) + pno3_bkginc(:,:,:) * zincwgt
+               END WHERE
 #else
                CALL ctl_stop ( ' bgc3d_asm_inc: no compatible BGC model defined' )
@@ -2015,4 +2568,10 @@
                   trn(:,:,:,jpsil) = trn(:,:,:,jpsil) + psi4_bkginc(:,:,:) * zincwgt
                   trb(:,:,:,jpsil) = trb(:,:,:,jpsil) + psi4_bkginc(:,:,:) * zincwgt
+               END WHERE
+#elif defined key_fabm
+               WHERE( psi4_bkginc(:,:,:) > 0.0_wp .OR. &
+                  &   trn(:,:,:,jp_fabm_n5s) + psi4_bkginc(:,:,:) * zincwgt > 0.0_wp )
+                  trn(:,:,:,jp_fabm_n5s) = trn(:,:,:,jp_fabm_n5s) + psi4_bkginc(:,:,:) * zincwgt
+                  trb(:,:,:,jp_fabm_n5s) = trb(:,:,:,jp_fabm_n5s) + psi4_bkginc(:,:,:) * zincwgt
                END WHERE
 #else
@@ -2034,4 +2593,10 @@
                   trb(:,:,:,jpdic) = trb(:,:,:,jpdic) + pdic_bkginc(:,:,:) * zincwgt
                END WHERE
+#elif defined key_fabm
+               WHERE( pdic_bkginc(:,:,:) > 0.0_wp .OR. &
+                  &   trn(:,:,:,jp_fabm_o3c) + pdic_bkginc(:,:,:) * zincwgt > 0.0_wp )
+                  trn(:,:,:,jp_fabm_o3c) = trn(:,:,:,jp_fabm_o3c) + pdic_bkginc(:,:,:) * zincwgt
+                  trb(:,:,:,jp_fabm_o3c) = trb(:,:,:,jp_fabm_o3c) + pdic_bkginc(:,:,:) * zincwgt
+               END WHERE
 #else
                CALL ctl_stop ( ' bgc3d_asm_inc: no compatible BGC model defined' )
@@ -2052,4 +2617,10 @@
                   trb(:,:,:,jpalk) = trb(:,:,:,jpalk) + palk_bkginc(:,:,:) * zincwgt
                END WHERE
+#elif defined key_fabm
+               WHERE( palk_bkginc(:,:,:) > 0.0_wp .OR. &
+                  &   trn(:,:,:,jp_fabm_o3ba) + palk_bkginc(:,:,:) * zincwgt > 0.0_wp )
+                  trn(:,:,:,jp_fabm_o3ba) = trn(:,:,:,jp_fabm_o3ba) + palk_bkginc(:,:,:) * zincwgt
+                  trb(:,:,:,jp_fabm_o3ba) = trb(:,:,:,jp_fabm_o3ba) + palk_bkginc(:,:,:) * zincwgt
+               END WHERE
 #else
                CALL ctl_stop ( ' bgc3d_asm_inc: no compatible BGC model defined' )
@@ -2063,4 +2634,10 @@
                   trn(:,:,:,jpoxy) = trn(:,:,:,jpoxy) + po2_bkginc(:,:,:) * zincwgt
                   trb(:,:,:,jpoxy) = trb(:,:,:,jpoxy) + po2_bkginc(:,:,:) * zincwgt
+               END WHERE
+#elif defined key_fabm
+               WHERE( po2_bkginc(:,:,:) > 0.0_wp .OR. &
+                  &   trn(:,:,:,jp_fabm_o2o) + po2_bkginc(:,:,:) * zincwgt > 0.0_wp )
+                  trn(:,:,:,jp_fabm_o2o) = trn(:,:,:,jp_fabm_o2o) + po2_bkginc(:,:,:) * zincwgt
+                  trb(:,:,:,jp_fabm_o2o) = trb(:,:,:,jp_fabm_o2o) + po2_bkginc(:,:,:) * zincwgt
                END WHERE
 #else
@@ -2091,11 +2668,6 @@
             ! Initialize the now fields with the background + increment
             ! Background currently is what the model is initialised with
-#if defined key_hadocc
-            CALL ctl_warn( ' Doing direct initialisation of HadOCC with 3D BGC assimilation', &
+            CALL ctl_warn( ' Doing direct initialisation with 3D BGC assimilation', &
                &           ' Background state is taken from model rather than background file' )
-#elif defined key_medusa
-            CALL ctl_warn( ' Doing direct initialisation of MEDUSA with 3D BGC assimilation', &
-               &           ' Background state is taken from model rather than background file' )
-#endif
 
             IF ( ln_pno3inc ) THEN
@@ -2112,4 +2684,10 @@
                   trb(:,:,:,jpdin) = trn(:,:,:,jpdin)
                END WHERE
+#elif defined key_fabm
+               WHERE( pno3_bkginc(:,:,:) > 0.0_wp .OR. &
+                  &   trn(:,:,:,jp_fabm_n3n) + pno3_bkginc(:,:,:) > 0.0_wp )
+                  trn(:,:,:,jp_fabm_n3n) = trn(:,:,:,jp_fabm_n3n) + pno3_bkginc(:,:,:)
+                  trb(:,:,:,jp_fabm_n3n) = trn(:,:,:,jp_fabm_n3n)
+               END WHERE
 #else
                CALL ctl_stop ( ' bgc3d_asm_inc: no compatible BGC model defined' )
@@ -2123,4 +2701,10 @@
                   trn(:,:,:,jpsil) = trn(:,:,:,jpsil) + psi4_bkginc(:,:,:)
                   trb(:,:,:,jpsil) = trn(:,:,:,jpsil)
+               END WHERE
+#elif defined key_fabm
+               WHERE( psi4_bkginc(:,:,:) > 0.0_wp .OR. &
+                  &   trn(:,:,:,jp_fabm_n5s) + psi4_bkginc(:,:,:) > 0.0_wp )
+                  trn(:,:,:,jp_fabm_n5s) = trn(:,:,:,jp_fabm_n5s) + psi4_bkginc(:,:,:)
+                  trb(:,:,:,jp_fabm_n5s) = trn(:,:,:,jp_fabm_n5s)
                END WHERE
 #else
@@ -2142,4 +2726,10 @@
                   trb(:,:,:,jpdic) = trn(:,:,:,jpdic)
                END WHERE
+#elif defined key_fabm
+               WHERE( pdic_bkginc(:,:,:) > 0.0_wp .OR. &
+                  &   trn(:,:,:,jp_fabm_o3c) + pdic_bkginc(:,:,:) > 0.0_wp )
+                  trn(:,:,:,jp_fabm_o3c) = trn(:,:,:,jp_fabm_o3c) + pdic_bkginc(:,:,:)
+                  trb(:,:,:,jp_fabm_o3c) = trn(:,:,:,jp_fabm_o3c)
+               END WHERE
 #else
                CALL ctl_stop ( ' bgc3d_asm_inc: no compatible BGC model defined' )
@@ -2160,4 +2750,10 @@
                   trb(:,:,:,jpalk) = trn(:,:,:,jpalk)
                END WHERE
+#elif defined key_fabm
+               WHERE( palk_bkginc(:,:,:) > 0.0_wp .OR. &
+                  &   trn(:,:,:,jp_fabm_o3ba) + palk_bkginc(:,:,:) > 0.0_wp )
+                  trn(:,:,:,jp_fabm_o3ba) = trn(:,:,:,jp_fabm_o3ba) + palk_bkginc(:,:,:)
+                  trb(:,:,:,jp_fabm_o3ba) = trn(:,:,:,jp_fabm_o3ba)
+               END WHERE
 #else
                CALL ctl_stop ( ' bgc3d_asm_inc: no compatible BGC model defined' )
@@ -2171,4 +2767,10 @@
                   trn(:,:,:,jpoxy) = trn(:,:,:,jpoxy) + po2_bkginc(:,:,:)
                   trb(:,:,:,jpoxy) = trn(:,:,:,jpoxy)
+               END WHERE
+#elif defined key_fabm
+               WHERE( po2_bkginc(:,:,:) > 0.0_wp .OR. &
+                  &   trn(:,:,:,jp_fabm_o2o) + po2_bkginc(:,:,:) > 0.0_wp )
+                  trn(:,:,:,jp_fabm_o2o) = trn(:,:,:,jp_fabm_o2o) + po2_bkginc(:,:,:)
+                  trb(:,:,:,jp_fabm_o2o) = trn(:,:,:,jp_fabm_o2o)
                END WHERE
 #else
Index: branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90
===================================================================
--- branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90	(revision 10574)
+++ branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90	(revision 10622)
@@ -52,5 +52,7 @@
    USE asminc, ONLY: ln_avgbkg
 #if defined key_top
-   USE asmbgc, ONLY: asm_bgc_bkg_wri
+   USE asmbgc, ONLY: asm_bgc_bkg_alloc, &
+      &              asm_bgc_bkg_tavg,  &
+      &              asm_bgc_bkg_wri
 #endif
    IMPLICIT NONE
@@ -140,5 +142,12 @@
          
          numtimes_tavg = REAL ( nitavgbkg_r -  nn_it000 + 1 )
-      ENDIF   
+      ENDIF
+      
+#if defined key_top
+      ! Allocate BGC average arrays whatever, to save code repetition later
+      IF ( kt == ( nn_it000 - 1) ) THEN
+         CALL asm_bgc_bkg_alloc
+      ENDIF
+#endif
 
       ! If creating an averaged assim bkg, sum the contribution every timestep
@@ -157,4 +166,7 @@
 #if defined key_zdftke
          en_tavg(:,:,:)       = en_tavg(:,:,:) + en(:,:,:) / numtimes_tavg
+#endif
+#if defined key_top
+         CALL asm_bgc_bkg_tavg( kt, numtimes_tavg )
 #endif
       ENDIF
@@ -226,5 +238,5 @@
             
 #if defined key_top
-            CALL asm_bgc_bkg_wri( kt, inum )
+            CALL asm_bgc_bkg_wri( kt, inum, ln_avgbkg )
 #endif
             CALL iom_close( inum )
Index: branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90
===================================================================
--- branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 10574)
+++ branches/UKMO/AMM15_v3_6_STABLE_package_collate_BGC_DA/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 10622)
@@ -167,4 +167,5 @@
          &                 ln_trainc, ln_dyninc, ln_sshinc,                &
          &                 ln_phytobal, ln_slchltotinc, ln_slchldiainc,    &
+         &                 ln_slchlnaninc, ln_slchlpicinc, ln_slchldininc, &
          &                 ln_slchlnoninc, ln_schltotinc, ln_slphytotinc,  &
          &                 ln_slphydiainc, ln_slphynoninc, ln_spco2inc,    &
@@ -228,4 +229,7 @@
          WRITE(numout,*) '      Logical switch for applying slchldia increments     ln_slchldiainc = ', ln_slchldiainc
          WRITE(numout,*) '      Logical switch for applying slchlnon increments     ln_slchlnoninc = ', ln_slchlnoninc
+         WRITE(numout,*) '      Logical switch for applying slchlnan increments     ln_slchlnaninc = ', ln_slchlnaninc
+         WRITE(numout,*) '      Logical switch for applying slchlpic increments     ln_slchlpicinc = ', ln_slchlpicinc
+         WRITE(numout,*) '      Logical switch for applying slchldin increments     ln_slchldininc = ', ln_slchldininc
          WRITE(numout,*) '      Logical switch for applying schltot increments       ln_schltotinc = ', ln_schltotinc
          WRITE(numout,*) '      Logical switch for applying slphytot increments     ln_slphytotinc = ', ln_slphytotinc
@@ -295,4 +299,5 @@
       ENDIF
       IF ( ln_slchltotinc .OR. ln_slchldiainc .OR. ln_slchlnoninc .OR. &
+         & ln_slchlnaninc .OR. ln_slchlpicinc .OR. ln_slchldininc .OR. &
          & ln_schltotinc  .OR. ln_slphytotinc .OR. ln_slphydiainc .OR. &
          & ln_slphynoninc .OR. ln_spco2inc    .OR. ln_sfco2inc    .OR. &
@@ -1353,4 +1358,5 @@
       ! Ocean colour variables first
       IF ( ln_slchltotinc .OR. ln_slchldiainc .OR. ln_slchlnoninc .OR. &
+         & ln_slchlnaninc .OR. ln_slchlpicinc .OR. ln_slchldininc .OR. &
          & ln_schltotinc  .OR. ln_slphytotinc .OR. ln_slphydiainc .OR. &
          & ln_slphynoninc ) THEN
